X-Git-Url: https://zdv2.bktei.com/gitweb/BK-2020-03.git/blobdiff_plain/25f31c307d823524d1ba69aed4e51e07f232f083..b8b1e3a2953e1fde7669868e6b3921c8648f0e37:/unitproc/bktemp-timeDuration

diff --git a/unitproc/bktemp-timeDuration b/unitproc/bktemp-timeDuration
index 090b485..21c9d69 100644
--- a/unitproc/bktemp-timeDuration
+++ b/unitproc/bktemp-timeDuration
@@ -6,62 +6,61 @@ yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; #
 die() { yell "$*"; exit 111; }
 try() { "$@" || die "cannot $*"; }
 timeDuration(){
-    # Desc: Output approximate time duration string before given time (default:current date)
+    # Desc: Given seconds, output ISO-8601 duration string
     # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
     # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
-    # Usage: timeDuration [arg1] ([arg2])
-    # Version: 1.0.0
+    # Usage: timeDuration [1:seconds] ([2:precision])
+    # Version: 1.0.3
     # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
     #        arg2: precision level (optional; default=2)
     # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+    #         exit code 0: success
+    #         exit code 1: error_input
+    #         exit code 2: error_unknown
     # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
     # Depends: date 8 (gnucoreutils), yell, 
-    local returnState ARG1 ARG2 arg1Valid arg2Valid remainder precision witherPrecision
+    local returnState argSeconds argPrecision remainder precision witherPrecision
     local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
     local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
     local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
     
-    ARG1="$1";
-    ARG2="$2";
+    argSeconds="$1"; # read arg1 (seconds)
+    argPrecision="$2"; # read arg2 (precision)
     precision=2; # set default precision
-    returnState="true"; # set default return state
 
     # Check that between one and two arguments is supplied
     if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
 	yell "ERROR:Invalid number of arguments:$# . Exiting.";
-	returnState="ERROR_INPUT"; fi
+	returnState="error_input"; fi
 
-    # Check that arg1 provided
+    # Check that argSeconds provided
     if [[ $# -ge 1 ]]; then
-	# Check that arg1 is a positive integer
-	if [[ "$ARG1" =~ ^[[:digit:]]+$ ]]; then
-   	    arg1Valid="true";
+	## Check that argSeconds is a positive integer
+	if [[ "$argSeconds" =~ ^[[:digit:]]+$ ]]; then
+   	    :
 	else
-	    yell "ERROR:ARG1 not a digit.";
-	    returnState="ERROR_INPUT";
-	    arg1Valid="false";
+	    yell "ERROR:argSeconds not a digit.";
+	    returnState="error_input";
 	fi
     else
 	yell "ERROR:No argument provided. Exiting.";
 	exit 1;
     fi
 
-    # Consider whether arg2 was provided
+    # Consider whether argPrecision was provided
     if  [[ $# -eq 2 ]]; then
-	# Check that the second arg is a positive integer
-	if [[ "$ARG2" =~ ^[[:digit:]]+$ ]] && [[ "$ARG2" -gt 0 ]]; then
-	arg2Valid="true";
-	precision="$ARG2";
+	# Check that argPrecision is a positive integer
+	if [[ "$argPrecision" =~ ^[[:digit:]]+$ ]] && [[ "$argPrecision" -gt 0 ]]; then
+	precision="$argPrecision";
 	else
-	    yell "ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
-	    returnState="ERROR_INPUT";
-	    arg2Valid="false";
+	    yell "ERROR:argPrecision not a positive integer. (is $argPrecision ). Leaving early.";
+	    returnState="error_input";
 	fi;
     else
-	arg2Valid="false";
+	:
     fi;
     
-    remainder="$ARG1" ; # seconds
+    remainder="$argSeconds" ; # seconds
     ## Calculate full years Y, update remainder
     fullYears=$(( remainder / (365*24*60*60) ));
     remainder=$(( remainder - (fullYears*365*24*60*60) ));
@@ -161,8 +160,6 @@ timeDuration(){
     fi;
     if $witherPrecision; then ((precision--)); fi;
 
-
-
     ## Determine whether or not the "T" separator is needed to separate date and time elements
     if ( $displayHours || $displayMinutes || $displaySeconds); then
 	displayDateTime="true"; else displayDateTime="false"; fi
@@ -185,14 +182,17 @@ timeDuration(){
 	OUTPUT=$OUTPUT$fullSeconds"S"; fi
 
     ## Output duration string to stdout
-    if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi
+    echo "$OUTPUT" && returnState="true";
 
     #===Determine function return code===
     if [ "$returnState" = "true" ]; then
 	return 0;
-    else
-	echo "$returnState" 1>&2;
+    elif [ "$returnState" = "error_input" ]; then
+	yell "ERROR:input";
 	return 1;
+    else
+	yell "ERROR:Unknown";
+	return 2;
     fi
 
 } # Get duration (ex: PT10M4S )